﻿using System;
using System.Runtime.InteropServices;
using System.ComponentModel;
using System.Windows.Forms;
using AddinExpress.MSO;
using System.Diagnostics;

namespace ReplyAllContextMenu2003
{
    /// <summary>
    ///   Add-in Express Add-in Module
    /// </summary>
    [GuidAttribute("509CD06C-5C6D-405E-9B86-BDD5F9C1D2ED"), ProgId("ReplyAllContextMenu2003-cs.AddinModule")]
    public class AddinModule : AddinExpress.MSO.ADXAddinModule
    {
        public AddinModule()
        {
            Application.EnableVisualStyles();
            InitializeComponent();
            // Please add any initialization code to the AddinInitialize event handler
        }

        private ADXOutlookAppEvents adxOutlookEvents;
        private ADXBuiltInControl adxBuiltInControl1;
 
        #region Component Designer generated code
        /// <summary>
        /// Required by designer
        /// </summary>
        private System.ComponentModel.IContainer components;
 
        /// <summary>
        /// Required by designer support - do not modify
        /// the following method
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            this.adxOutlookEvents = new AddinExpress.MSO.ADXOutlookAppEvents(this.components);
            this.adxBuiltInControl1 = new AddinExpress.MSO.ADXBuiltInControl(this.components);
            // 
            // adxOutlookEvents
            // 
            this.adxOutlookEvents.NewInspector += new AddinExpress.MSO.ADXOlInspector_EventHandler(this.adxOutlookEvents_NewInspector);
            // 
            // adxBuiltInControl1
            // 
            this.adxBuiltInControl1.CommandBar = null;
            this.adxBuiltInControl1.ControlTag = "606a6928-42a9-4023-8db2-19a81e00f99c";
            this.adxBuiltInControl1.Id = 354;
            this.adxBuiltInControl1.ActionEx += new AddinExpress.MSO.ADXActionEx_EventHandler(this.adxBuiltInControl1_ActionEx);
            // 
            // AddinModule
            // 
            this.AddinName = "ReplyAllContextMenu2003-cs";
            this.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaOutlook;
            this.OnSendMessage += new AddinExpress.MSO.ADXSendMessage_EventHandler(this.AddinModule_OnSendMessage);
            this.AddinBeginShutdown += new AddinExpress.MSO.ADXEvents_EventHandler(this.AddinModule_AddinBeginShutdown);
            this.AddinStartupComplete += new AddinExpress.MSO.ADXEvents_EventHandler(this.AddinModule_AddinStartupComplete);

        }
        #endregion
 
        #region Add-in Express automatic code
 
        // Required by Add-in Express - do not modify
        // the methods within this region
 
        public override System.ComponentModel.IContainer GetContainer()
        {
            if (components == null)
                components = new System.ComponentModel.Container();
            return components;
        }
 
        [ComRegisterFunctionAttribute]
        public static void AddinRegister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXRegister(t);
        }
 
        [ComUnregisterFunctionAttribute]
        public static void AddinUnregister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXUnregister(t);
        }
 
        public override void UninstallControls()
        {
            base.UninstallControls();
        }

        #endregion

        public static new AddinModule CurrentInstance 
        {
            get
            {
                return AddinExpress.MSO.ADXAddinModule.CurrentInstance as AddinModule;
            }
        }

        public Outlook._Application OutlookApp
        {
            get
            {
                return (HostApplication as Outlook._Application);
            }
        }

        bool waitForInspector = false;
        InspectorStopper inspectorStopper = null;
        ReplyAllChecker replyAllChecker = null;
        string EntryID = "";
        private const int WM_USER = 0x0400;
        private int WM_Reply = WM_USER + 1000;

        /// <summary>
        /// Handles clicking on any Reply button in Outlook
        /// </summary>
        private void adxBuiltInControl1_ActionEx(object sender, ADXCancelEventArgs e)
        {
            Debug.Print("ProcessReplyButtonClick. A Reply button is clicked.");
            if (this.HostMajorVersion != 11)
            {
                Debug.Print("Only handle Outlook 2003");
                return;
            }
            Debug.Print("Make sure that the Reply button is located on 'Context Menu'.");
            
            Office.CommandBarButton replyButton = e.Control as Office.CommandBarButton;
            Office.CommandBar contextMenu = replyButton.Parent;
            if (contextMenu.Name == "Context Menu")
            {
                Debug.Print("Step 1. Open the right-clicked item and cancel the Reply action");
                Office.CommandBarControls controls = contextMenu.Controls;
                Office.CommandBarControl buttonOpen = controls["Open"];
                if (buttonOpen != null)
                {
                    if (buttonOpen.Visible)
                    {
                        buttonOpen.Execute();

                        Debug.Print("Cancel the Reply action");
                        e.Cancel = true;
                        waitForInspector = true;
                    }
                    Marshal.ReleaseComObject(buttonOpen); buttonOpen = null;
                }
                Marshal.ReleaseComObject(controls); controls = null;
            }
            Marshal.ReleaseComObject(contextMenu); contextMenu = null;
            Debug.Print("ProcessReplyButtonClick. Exit");
        }

        private void adxOutlookEvents_NewInspector(object sender, object inspector, string folderName)
        {
            Debug.Print("adxOutlookEvents_NewInspector");
            if (waitForInspector)
            {
                Debug.Print("Step 2. Get the EntryID of the right-clicked item; prevent the item from opening");
                object item = (inspector as Outlook._Inspector).CurrentItem;
                if (item is Outlook.MailItem)
                {
                    Outlook.MailItem mail = item as Outlook.MailItem;
                    EntryID = mail.EntryID;
                    Debug.Print("Save the right-clicked item's EntryID");

                    Debug.Print("Prevent the right-clicked item from opening");
                    // inspectorStopper cancels the Open event of the item
                    inspectorStopper.ConnectTo(mail, true);

                    Debug.Print("Initiate Step 3.");
                    this.SendMessage(WM_Reply);
                }
                else
                {
                    Debug.Print("adxOutlookEvents_NewInspector. Oops! This is not a MailItem... :( ");
                }
                waitForInspector = false;
            }
            Debug.Print("adxOutlookEvents_NewInspector. Exit");
        }

        /// <summary>
        /// When the WM_Reply window message is received, retrieves the email and creates a reply email
        /// </summary>
        private void AddinModule_OnSendMessage(object sender, ADXSendMessageEventArgs e)
        {
            if (e.Message == WM_Reply)
            {
                Debug.Print("AddinModule_OnSendMessage. Handle WM_Reply");
                if (this.EntryID != "")
                {
                    Debug.Print("Step 3. Re-get the right-clicked item and create a reply");
                    object item = GetItemFromEntryID();
                    if (item != null)
                    {
                        if (item is Outlook.MailItem)
                        {
                            Outlook.MailItem mail = item as Outlook.MailItem;
                            Debug.Print("Connecting replyAllChecker to the right-clicked item.");
                            replyAllChecker.ConnectTo(mail, true);

                            Outlook.MailItem reply = null;

                            try
                            {
                                // mail.Reply() generates the Reply event, it is processed by replyAllChecker
                                reply = mail.Reply();
                                if (reply != null)
                                {
                                    reply.Display(false);
                                    Debug.Print("The reply is created and displayed sucessfully");
                                }
                            }
                            catch(Exception ex)
                            {
                                Debug.Print(ex.Message);
                            }
                            finally
                            {
                                if (reply != null) 
                                    Marshal.ReleaseComObject(reply);
                            }

                            Debug.Print("Disconnecting replyAllChecker from the previously connected item.");
                            replyAllChecker.RemoveConnection();
                        }
                    }
                }
                Debug.Print("AddinModule_OnSendMessage. Exit");
            }
        }

        private object GetItemFromEntryID()
        {
            object item = null;
            Outlook.NameSpace ns = OutlookApp.Session;
            try
            {
                item = ns.GetItemFromID(this.EntryID, Type.Missing);
            }
            catch
            {
                Debug.Print("GetItemFromEntryID. The item has been moved or deleted");
            }
            Marshal.ReleaseComObject(ns); ns = null;
            return item;
        }

        private void AddinModule_AddinStartupComplete(object sender, EventArgs e)
        {
            Debug.Print("The AddinStartupComplete event has occured.");
            Debug.Print("The add-in has been loaded by Outlook " + this.HostMajorVersion.ToString());

            // This creates an instance of the class that handles the events of an Outlook item
            replyAllChecker = new ReplyAllChecker(this);
            inspectorStopper = new InspectorStopper(this);
        }

        private void AddinModule_AddinBeginShutdown(object sender, EventArgs e)
        {
            Debug.Print("The AddinBeginShutdown event has occured.");
            replyAllChecker = null;
            inspectorStopper = null;
        }
    }
}

